package de.hft.stuttgart.citydoctor2.gui.tree;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

import de.hft.stuttgart.citydoctor2.datastructure.Vertex;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class VertexNode extends Renderable {
	
	private static DecimalFormat nf;
	
	static {
		DecimalFormatSymbols dfs = DecimalFormatSymbols.getInstance();
		dfs.setDecimalSeparator('.');
		nf = new DecimalFormat("#.########", dfs);
	}
	
	private static final String SEPERATOR = ", ";
	private Vertex v;
	private String text;
	
	public VertexNode(Vertex v) {
		this.v = v;
	}

	@Override
	public void refreshTextColor() {
		// not used
	}

	@Override
	public String getText() {
		if (text == null) {
			StringBuilder sb = new StringBuilder();
			sb.append("Vertex [");
			sb.append(nf.format(v.getX()));
			sb.append(SEPERATOR);
			sb.append(nf.format(v.getY()));
			sb.append(SEPERATOR);
			sb.append(nf.format(v.getZ()));
			sb.append("]");
			text = sb.toString();
		}
		return text;
	}

	@Override
	public void visit(Renderer renderer) {
		renderer.highlight(v);
	}

}
